// Orugime, Ichido, Yorichy and Matsumotsu
//
// Izquierda                       Derecha
//   Ichido      c                    Orugime   o
//   Yorichy     i                    Yorichy   d
//   Matsumotsu  m
//

var LEFT_OFFSCREEN = {
			'c': -336,
			'i': -330,
			'm': -290
		},
		LEFT_POSITION = {
			'c': 224,
			'i': 183,
			'm': 220
		},
		CENTER_LEFT = {
			'c': 531.5,
			'i': 638,
			'm': 592.5
		},
		RIGHT_OFFSCREEN = {
			'o': 1700,
			'd': 1615
		},
		RIGHT_POSITION = {
			'o': 1090,
			'd': 1097
		},
		CENTER_RIGHT = {
			'o': 694,
			'd': 643.5
		};

function charPoseChange(chr, chr2, newFrame, time, callback=function(){}) {
	if(chr.currentFrame != newFrame) {
		var t1 = t2 = time/3;
		var t12 = t1+t2;
		var t3 = time-t12;
		var t4 = time-t1;

		chr2.gotoAndStop(chr.currentFrame);
		chr2.x = chr.x;
		chr2.y = chr.y;
		chr2.alpha = 1;
		chr2.visible = true;

		createjs.Tween.get(chr2)
			.wait(t12)
			.call(function(){
				chr2.gotoAndStop(newFrame);
			})
			.wait(t3)
			.call(function(){
				chr2.visible = false;
				chr2.alpha = 0;
			});

	  createjs.Tween.get(chr)
			.to({alpha: 0.6}, t1)
	    .call(function(){
	      chr.gotoAndStop(newFrame);
	    })
	    .to({alpha: 1}, t4)
			.call(function() {
				callback();
			});
	} else
		createjs.Tween.get(chr)
			.wait(100)
			.call(function() {
				callback();
			});
}

function charToPos(chr, pos, time, callback=function(){}) {
  createjs.Tween.get(chr)
		.to(chr.position)
		.to({x: pos}, time)
		.call(function() {
			callback();
		});
}

function charEnterLeft(chr, time, callback=function(){}) {
	createjs.Tween.get(chr)
		.to(chr.position)
		.to({x: LEFT_POSITION[chr.name]}, time)
		.call(function() {
			callback();
		});
}

function charEnterRight(chr, time, callback=function(){}) {
	createjs.Tween.get(chr)
		.to(chr.position)
		.to({x: RIGHT_POSITION[chr.name]}, time)
		.call(function() {
			callback();
		});
}

function charLeaveLeft(chr, time, callback=function(){}) {
	createjs.Tween.get(chr)
		.to(chr.position)
		.to({x: LEFT_OFFSCREEN[chr.name]}, time)
		.call(function() {
			callback();
		});
}

function charLeaveRight(chr, time, callback=function(){}) {
	createjs.Tween.get(chr)
		.to(chr.position)
		.to({x: RIGHT_OFFSCREEN[chr.name]}, time,)
		.call(function() {
			callback();
		});
}

function charToCenterFromLeft(chr, time, callback=function(){}) {
  createjs.Tween.get(chr)
		.to(chr.position)
		.to({x: CENTER_LEFT[chr.name]}, time)
		.call(function() {
			callback();
		});
}

function charToCenterFromRight(chr, time, callback=function(){}) {
  createjs.Tween.get(chr)
    .to(chr.position)
    .to({x: CENTER_RIGHT[chr.name]}, time)
    .call(function() {
      callback();
    });
}

function charLeaveLeftFromCenter(chr, time, callback=function(){}) {
  createjs.Tween.get(chr)
		.to(chr.position)
		.to({x: LEFT_OFFSCREEN[chr.name]}, time)
		.call(function() {
			callback();
		});
}

function charLeaveRightFromCenter(chr, time, callback=function(){}) {
  createjs.Tween.get(chr)
		.to(chr.position)
		.to({x: RIGHT_OFFSCREEN[chr.name]}, time)
		.call(function() {
			callback();
		});
}

function charFade(chr, time, callback=function(){}) {
	createjs.Tween.get(chr)
		.to({alpha: 0}, time)
		.call(function() {
			callback();
		});
}

function charShow(chr, time, callback=function(){}) {
	createjs.Tween.get(chr)
		.to({alpha: 1}, time)
		.call(function() {
			callback();
		});
}

function charWait(chr, time, callback=function(){}) {
  createjs.Tween.get(chr)
		.wait(time)
		.call(function() {
			callback();
		});
}
