// BehaviourHelper v0.1.509
function createGameVariables(rt) {
  // EventDirector variables
  rt.EDV = {};                      // EventDirector variables
  rt.EH = {};                       // Event handlers
  rt.RH = {};                       // Regular handlers
  rt.EA = new EventsArray(rt.EDV); // Events Array

  // Config variables
  if(rt.GCFG == undefined)
  	rt.GCFG = {};

  if(rt.GCFG.LANG == undefined)
    rt.GCFG.LANG = "ENG";

  if(rt.GCFG.SCREEN == undefined)
  	rt.GCFG.SCREEN = "NORMAL";

  // Sound variables
  rt.GCFG.playStatus = 0;
  rt.GCFG.SOUND = true;

  // Interface status variables
  if(rt.GCFG.OBJECTS_VISIBLE == undefined)
  	rt.GCFG.OBJECTS_VISIBLE = true;

  if(rt.GCFG.NEW_GAME == undefined)
  	rt.GCFG.NEW_GAME = true;

  // Game sounds object, stores the name of all sounds used by the game
  if(rt.SLIB == undefined)
  	rt.SLIB = {};

  // Súper listeners, for most of the functions here
  if(rt.SUPER_LIST == undefined)
    rt.SUPER_LIST = {};
}

function setFullscreenFunctionality(rt, listenerName="SCREEN_CHANGED") {
  if(rt.SUPER_LIST.screenListener == undefined) { // Súper listeners
  	rt.SUPER_LIST.screenListener = rt.on(listenerName, fnToggleFullscreen);
  }

  function fnToggleFullscreen(e) {
  	if(rt.GCFG.SCREEN == "FULLSCREEN")
  		enterFS($("#animation_container")[0]);
  	else
  		exitFS();
  }
  function enterFS(elem) {
  	if(elem.requestFullscreen) {
  		elem.requestFullscreen();
  	} else if(elem.mozRequestFullScreen) {
  		elem.mozRequestFullScreen();
  	} else if(elem.webkitRequestFullscreen) {
  		elem.webkitRequestFullscreen();
  	} else if(elem.msRequestFullscreen) {
  		elem.msRequestFullscreen();
  	}
  }
  function exitFS() {
  	if(document.exitFullscreen) {
  		document.exitFullscreen();
  	} else if(document.mozCancelFullScreen) {
  		document.mozCancelFullScreen();
  	} else if(document.webkitExitFullscreen) {
  		document.webkitExitFullscreen();
  	}
  }
}

function setSoundFunctionality(rt, listenerName="SOUND_STATUS_CHANGED") {
  if(rt.SUPER_LIST.soundListener == undefined)
	  rt.SUPER_LIST.soundListener = rt.on(listenerName, fnToggleSound);

  function fnToggleSound(e) {
  	if(rt.GCFG.SOUND) {
  		rt.SLIB.GeneralAudio.play();
  	} else {
      rt.SLIB.GeneralAudio.stop();
  	}
  }
}

//function setLanguageFunctionality

function setGotoSiteFunctionality(rt, button) {
  if(button && (typeof button.hasEventListener === "function"))
    if(!button.hasEventListener("click"))
      button.addEventListener("click", function(e) {
        window.open("https://www.mysexgames.com/", "_blank");
      })

  /*
  if(!button.hasEventListener("click"))
    button.addEventListener("click", function(e) {
      window.open("https://mysexgames.com/", "_blank");
    })
  */
}

function setAfterIntroFunctionality(rt, button, gotoLabel="lblStart") {
  button.visible = false;

  if(rt.SUPER_LIST.introFinished == undefined) {
  	rt.SUPER_LIST.introFinished = rt.on("INTRO_COMPLETED", function(e) {
    	button.visible = true;
    });
  }

  if(rt.btnNextIntroListener == undefined)
  	rt.btnNextIntroListener = button.on("click", function(e) {
  		rt.gotoAndStop(gotoLabel);
  	});
}

// Usage: addSoundToLib(exportRoot, [["AudioName", "./sounds/file.mp3", true]])
function addSoundToLib(rt, soundArray) {
  soundArray.forEach(function(lst){
    createjs.Sound.registerSound(lst[1], lst[0]);
    if(lst[2]) // loop is true
      rt.SLIB[lst[1]] = createjs.Sound.play(lst[0], {loop:-1});
    else // Loop is false
      rt.SLIB[lst[1]] = createjs.Sound.play(lst[0]);
  });
}

function fillOptionsList(optionsArray) {
	optionsArray.forEach(function(e) {
		e[0].initVars();

		e[0].parentGivenFunct = e[1].funct;
		e[0].optionEngTxt = e[1].engTxt;
		e[0].optionEspTxt = e[1].espTxt;

		e[0].initState();
	});
}
