// Buttons Helper v0.2.403
function setFullscreenMCFunctionality(thy, rt) {
  if(!thy.btnActive.hasEventListener("click")) {
  	thy.btnActive.addEventListener("click", fnChangeStatus);
  }
  if(!thy.btnInactive.hasEventListener("click")) {
  	thy.btnInactive.addEventListener("click", fnChangeStatus);
  }

  if(thy.visibleStatusListener == undefined) {
  	thy.visibleStatusListener = rt.on("VISIBLE_STATUS_CHANGED", fnVisibleStatusChanged);
  }

  function fnChangeStatus(e) {
  	if(thy.currentFrame == 0) {
  		rt.GCFG.SCREEN = "FULLSCREEN";
  		thy.gotoAndStop(1);
  	} else {
  		rt.GCFG.SCREEN = "NORMAL";
  		thy.gotoAndStop(0);
  	}

  	rt.dispatchEvent("SCREEN_CHANGED");
  }

  function fnVisibleStatusChanged(e) {
  	thy.visible = rt.GCFG.OBJECTS_VISIBLE;
  };
}

function setVisibilityMCFunctionality(thy, rt) {
  if(!thy.btnActive.hasEventListener("click")) {
  	thy.btnActive.addEventListener("click", fnChangeStatus);
  }
  if(!thy.btnInactive.hasEventListener("click")) {
  	thy.btnInactive.addEventListener("click", fnChangeStatus);
  }

  function fnChangeStatus(e) {
    if(rt.GCFG.OBJECTS_VISIBLE) {
  		rt.GCFG.OBJECTS_VISIBLE = false;
  		thy.gotoAndStop(1);
  	} else {
  		thy.gotoAndStop(0);
  		rt.GCFG.OBJECTS_VISIBLE = true;
  	}

  	rt.dispatchEvent("VISIBLE_STATUS_CHANGED");
  }
}

function setSoundMCFunctionality(thy, rt) {
  if(!thy.btnActiveS.hasEventListener("click")) {
  	thy.btnActiveS.addEventListener("click", fnChangeStatus);
  }
  if(!thy.btnInactiveS.hasEventListener("click")) {
  	thy.btnInactiveS.addEventListener("click", fnChangeStatus);
  }

  if(thy.visibleStatusListener == undefined) {
    thy.visibleStatusListener = rt.on("VISIBLE_STATUS_CHANGED", fnVisibleStatusChanged);
  }

  function fnChangeStatus(e) {
    if(thy.currentFrame == 0){
  		rt.GCFG.SOUND = false;
  		thy.gotoAndStop(1);
  	} else {
  		rt.GCFG.SOUND = true;
  		thy.gotoAndStop(0);
  	}

  	rt.dispatchEvent("SOUND_STATUS_CHANGED");
  }

  function fnVisibleStatusChanged(e) {
  	thy.visible = rt.GCFG.OBJECTS_VISIBLE;
  };
}

function setLanguageFunctionality(thy, rt) {
  if(!thy.btnActive.hasEventListener("click"))
  	thy.btnActive.addEventListener("click", fnChangeStatus);
  if(!thy.btnInactive.hasEventListener("click"))
  	thy.btnInactive.addEventListener("click", fnChangeStatus);

  if(thy.visibleStatusListener == undefined) {
  	thy.visibleStatusListener = rt.on("VISIBLE_STATUS_CHANGED", fnVisibleStatusChanged);
  }

  function fnChangeStatus(e) {
    	if(thy.currentFrame == 0){
  		rt.GCFG.LANG = "ESP";
  		thy.gotoAndStop(1);
  	} else {
  		rt.GCFG.LANG = "ENG";
  		thy.gotoAndStop(0);
  	}

  	rt.dispatchEvent("LANG_CHANGED");
  }

  function fnVisibleStatusChanged(e) {
  	thy.visible = rt.GCFG.OBJECTS_VISIBLE;
  };
}

function setNextFunctionality(thy, rt, eName, turnActiveEvt, turnInactiveEvt, mainGroupLabel, ownerName) {
  if(!thy.btnActual.hasEventListener("click"))
  	thy.btnActual.addEventListener("click", fnDispatchEvent);

  if(!thy.hasEventListener(turnActiveEvt))
    thy.addEventListener(turnActiveEvt, turnActive);

  if(!thy.hasEventListener(turnInactiveEvt))
    thy.addEventListener(turnInactiveEvt, turnInactive);

  function fnDispatchEvent(e) {
  	rt.dispatchEvent(eName);
  }

  function turnActive(e) {
		thy.gotoAndStop(1);
	}

	function turnInactive(e) {
		thy.gotoAndStop(0);
	}

  function fnVisibleStatusChanged(e) {
    if(thy.shouldBeVisible == undefined)
      thy.shouldBeVisible = true;

  	thy.visible = rt.GCFG.OBJECTS_VISIBLE && thy.shouldBeVisible;
  }
}
