// Dialog Elements v0.1.509

// For WRITE_SPEED: 60 FPS / 3 (Quantity of letters by second showing by default)
function setDialogBoxFunctionality(thy, rt, WRITE_SPEED=1, mainGroupLabel="lblDialogs", ownerName="DIALOG_BOX") {
	thy.initVars = function() {
		rt.EA.turnOffAndDeleteEventsOfOwner(ownerName);
		//delete thy.readyChecker;

		delete thy.dialogValue;
		delete thy.writeSpeed;

		delete thy.tickActive;
		delete thy.skipDialog;

		thy.nameTag.text = "";
		thy.dialogText.text = "";
	}

	thy.labelsBC = function(text) {
		var letter = text.charAt(0).toLowerCase();
		switch(letter) {
			case 'i':
				thy.labels.gotoAndStop(1);
			case 'y':
				thy.labels.gotoAndStop(2);
			case 'm':
				thy.labels.gotoAndStop(3);
			default:
				thy.labels.gotoAndStop(0);
		}
	}

	thy.initState = function() {
		if(thy.shouldBeVisible == undefined)
			thy.shouldBeVisible = true;

		if(thy.dialogValue == undefined)
			thy.dialogValue = 0;

		if(thy.tickActive == undefined)
			thy.tickActive = false;

		if(thy.skipDialog == undefined)
			thy.skipDialog = false;

		if(thy.writeSpeed == undefined)
			thy.writeSpeed = WRITE_SPEED;

		fnFunctionAndLabels();

		rt.EDV.dialogBoxLangHandler = new EventDirector(
			rt.EH, "langListener", rt, "LANG_CHANGED", changeLabelsLang,
			rt, {owner: ownerName, groups: [mainGroupLabel, "nonWriter"]}
		);
		rt.EDV.dialogBoxNextHandler = new EventDirector(
			rt.EH, "nextListener", rt, "NEXT_DIALOG", nextDialog,
			rt, {owner: ownerName, groups: [mainGroupLabel, "exWriter"]}
		);
		rt.EDV.dialogBoxVisibleStatusHandler = new EventDirector(
			rt.EH, "dialogBoxVisibleStatusListener", rt, "VISIBLE_STATUS_CHANGED", fnVisibleStatusChanged,
			rt, {owner: ownerName, groups: [mainGroupLabel]}
		);
		rt.EDV.dialogBoxLangHandler.createEvent();
		rt.EDV.dialogBoxNextHandler.createEvent();
		rt.EDV.dialogBoxVisibleStatusHandler.createEvent();
	}

	function nextDialog(e) {
		if(thy.tickActive) {
			thy.skipDialog = true;
		} else {
			thy.skipDialog = false;
			thy.dialogValue += 1;

			if(thy.dialogValue < thy.dialogScheme.length) {
				thy.dialogScheme[thy.dialogValue-1].cllbck();
				fnFunctionAndLabels();
			} else
				thy.dialogScheme[thy.dialogValue-1].cllbck();
		}
	}

	function changeLabelsLang(e) {
		if(!(typeof thy.dialogScheme[thy.dialogValue] == 'undefined'))
			if(rt.GCFG.LANG == "ENG") {
				thy.nameTag.text = thy.dialogScheme[thy.dialogValue].engTag;
				//thy.labelsBC(thy.nameTag.text);
				thy.dialogText.text = thy.dialogScheme[thy.dialogValue].engTxt;
			} else {
				thy.nameTag.text = thy.dialogScheme[thy.dialogValue].espTag;
				//thy.labelsBC(thy.nameTag.text);
				thy.dialogText.text = thy.dialogScheme[thy.dialogValue].espTxt;
			}
	}

	function fnVisibleStatusChanged(e) {
		thy.visible = rt.GCFG.OBJECTS_VISIBLE && thy.shouldBeVisible;
	}

	function displayDialog() {
		var type = thy.dialogScheme[thy.dialogValue].type;

		switch(type) {
			case 1:
				thy.gotoAndStop("lblRegular");
			default:
				thy.gotoAndStop("lblChar"+(type-1));
		}
	}

	function fnFunctionAndLabels() {
		thy.dialogScheme[thy.dialogValue].fn(internalCallback);

		thy.dialogText.text = "";
		thy.nameTag.text = "";
		//thy.labelsBC(thy.nameTag.text);

	  thy.tempDialogText = (rt.GCFG.LANG == "ENG")? thy.dialogScheme[thy.dialogValue].engTxt : thy.dialogScheme[thy.dialogValue].espTxt;
		thy.tempNameTag = (rt.GCFG.LANG == "ENG")? thy.dialogScheme[thy.dialogValue].engTag : thy.dialogScheme[thy.dialogValue].espTag;
		//thy.labelsBC(thy.nameTag.text);

	  var tempDialogLength = thy.tempDialogText.length;
		var tempTagLength = thy.tempNameTag.length;
	  var dialogIndex = 0;
	  var internalCounter = 0;

		function internalCallback() {
	    displayDialog();

	    rt.EDV.dialogBoxWriteHandler = new EventDirector(
	      rt.EH, "writingDialogListener", rt, "tick", fnWriteDialog,
	      rt, {owner: ownerName, groups: [mainGroupLabel, "writer"]}
	    );
			thy.tickActive = true;
	    rt.EA.turnOffEventsOfGroup("nonWriter");
	    rt.EDV.dialogBoxWriteHandler.createEvent();

	    function fnWriteDialog(e) {
	      internalCounter += 1;

	      if((internalCounter%thy.writeSpeed) == 0) {
					if(dialogIndex < tempTagLength) {
	          thy.nameTag.text += thy.tempNameTag[dialogIndex];
						//thy.labelsBC(thy.nameTag.text);
					}

	        if(dialogIndex < tempDialogLength)
	          thy.dialogText.text += thy.tempDialogText[dialogIndex++];
					else {
	          rt.EA.turnOffAndDeleteEventsOfGroup("writer");
	          rt.EA.turnOnEventsOfGroup("nonWriter");

	          thy.writeSpeed = WRITE_SPEED;
						thy.tickActive = false;
						thy.skipDialog = false;

						changeLabelsLang(null);
	        }
	      }

				if(thy.skipDialog) {
					thy.nameTag.text = thy.tempNameTag;
					thy.dialogText.text = thy.tempDialogText;
					//thy.labelsBC(thy.nameTag.text);

					rt.EA.turnOffAndDeleteEventsOfGroup("writer");
					rt.EA.turnOnEventsOfGroup("nonWriter");

					thy.writeSpeed = WRITE_SPEED;
					thy.tickActive = false;
					thy.skipDialog = false;

					changeLabelsLang(null);
				}

	  		//changeLabelsLang(null);
	    }
		}
	}

	thy.readyChecker = true;
}

function setSelectorFunctionality(thy, rt, TEXT_HEIGHT=120, mainGroupLabel="lblDialogs", ownerSufix="_MC_SELECTOR") {
	if(thy.originalTextYPos == undefined)
		thy.originalTextYPos = thy.optionText.y;

	thy.initVars = function() {
		rt.EA.turnOffAndDeleteEventsOfOwner(thy.name+ownerSufix);

		thy.optionText.text = "";
	}

	thy.initState = function() {
		rt.EDV[thy.name+"_LANG_HANDLER"] = new EventDirector(
			rt.EH, thy.name+"_LangListener", rt, "LANG_CHANGED", fnChangeOptionText,
			rt, {owner: thy.name+ownerSufix, groups: [mainGroupLabel]}
		);
		rt.EDV[thy.name+"_BTN_HANDLER"] = new EventDirector(
			rt.EH, thy.name+"_ClickListener", thy.btnZone, "click", fnCallParentGivenFunct,
			rt, {owner: thy.name+ownerSufix, groups: [mainGroupLabel]}
		);
		rt.EDV[thy.name+"_LANG_HANDLER"].createEvent();
		rt.EDV[thy.name+"_BTN_HANDLER"].createEvent();

		fnChangeOptionText(null);

		thy.gotoAndStop(0);
	}

	function fnChangeOptionText(e) {
		if(rt.GCFG.LANG == "ENG")
			thy.optionText.text = thy.optionEngTxt;
		else
			thy.optionText.text = thy.optionEspTxt;

		thy.optionText.y = thy.originalTextYPos + ((TEXT_HEIGHT-thy.optionText.getBounds().height) / 2);
	}

	function fnCallParentGivenFunct(e) {
		thy.parentGivenFunct(e);
		thy.gotoAndStop(1);
	}
}

function setSelectorContainerFunctionality(thy, rt, mainGroupLabel="lblDialogs", ownerName="MC_SELECTOR_CONTAINER") {
	if(thy.shouldBeVisible == undefined)
		thy.shouldBeVisible = false;

	thy.initVars = function() {
		rt.EDV.mcSelectVisibleStatusHandler = new EventDirector(
			rt.EH, "mcSelectVisibleStatusListener", rt, "VISIBLE_STATUS_CHANGED", fnVisibleStatusChanged,
			rt, {owner: ownerName, groups: [mainGroupLabel]}
		);
		rt.EDV.mcSelectVisibleStatusHandler.createEvent();

		delete thy.readyChecker;
	}

	function fnVisibleStatusChanged(e) {
		thy.visible = rt.GCFG.OBJECTS_VISIBLE && thy.shouldBeVisible;
	}

	thy.readyChecker = true;
}

function setNextDialogsFunctionality(thy, rt, mainGroupLabel="lblDialogs", ownerName="MC_BTN_NEXT") {
	if(thy.shouldBeVisible == undefined)
		thy.shouldBeVisible = true;

	thy.initVars = function(){
		rt.EA.turnOffAndDeleteEventsOfOwner(ownerName);

		delete thy.readyChecker;
	}

	thy.initState = function() {
		rt.EDV.mcBtnNext_Dialogs = new EventDirector(
			rt.EH, "btnNextLblDialogs", thy.btnActual, "click", fnNextButtonClick,
			rt, {owner: ownerName, groups: [mainGroupLabel]}
		);
		rt.EDV.mcBtnNextVisibleStatusHandler = new EventDirector(
			rt.EH, "mcBtnNextVisibleStatusListener", rt, "VISIBLE_STATUS_CHANGED", fnVisibleStatusChanged,
			rt, {owner: ownerName, groups: [mainGroupLabel]}
		);
		rt.EDV.mcBtnNext_Dialogs.createEvent();
		rt.EDV.mcBtnNextVisibleStatusHandler.createEvent();
	}

	thy.turnActive = function() {
		thy.gotoAndStop(1);
	}

	thy.turnInactive = function() {
		thy.gotoAndStop(0);
	}

	function fnVisibleStatusChanged(e) {
		thy.visible = rt.GCFG.OBJECTS_VISIBLE && thy.shouldBeVisible;
	}

	function fnNextButtonClick() {
		rt.dispatchEvent("NEXT_DIALOG");
	}

	thy.readyChecker = true;
}
