// FlowHelper v0.2.214

function waitForFrameReady(frameInstance, readyFunction, objectsToCheck) {
	console.log("waiting for frame ready");
	frameInstance.tlc = {}; // Temporal listeners container
	if(frameInstance.tlc.readyCheckListener == undefined)
		frameInstance.tlc.readyCheckListener = frameInstance.on("tick", fnReadyCheck);
	if(frameInstance.tlc.frameReadyListener == undefined)
		frameInstance.tlc.frameReadyListener = frameInstance.on("FRAME_READY", fnReadyDispatched);

	function fnReadyCheck(e) {
		console.log("on fnReadyCheck");
		var allReady = true;
		var arrLen = objectsToCheck.length;

		for(var i=0; i<arrLen; i++) {
			console.log("obj: "+objectsToCheck[i].readyChecker)
			if(!objectsToCheck[i].readyChecker) {
				allReady = false;
				break;
			}
		}

		if(allReady) {
			frameInstance.off("tick", frameInstance.tlc.readyCheckListener);
			delete frameInstance.tlc.readyCheckListener;

			frameInstance.dispatchEvent("FRAME_READY");
		}
	}

	function fnReadyDispatched(e) {
		console.log("on fnReadyDispatched");
		frameInstance.off("FRAME_READY", frameInstance.tlc.frameReadyListener);
		delete frameInstance.tlc.frameReadyListener;

		delete frameInstance.tlc;

		readyFunction();
	}
}

function cancelFrameWait(frameInstance) {
	frameInstance.off("tick", frameInstance.tlc.readyCheckListener);
	frameInstance.off("FRAME_READY", frameInstance.tlc.frameReadyListener);

	delete frameInstance.tlc.readyCheckListener;
	delete frameInstance.tlc.frameReadyListener;
	delete frameInstance.tlc;
}
