// movieContainerHelper v0.2.228

function setControlsContainerFunctionality(thy, rt, mainGroupLabel="lblMovie", ownerName="CONTROLS_CONTAINER") {
  thy.initVars = function() {
  	rt.EA.turnOffAndDeleteEventsOfGroup(mainGroupLabel);

  	delete thy.readyChecker;
  }

  thy.initState = function(freeMode) {
  	thy.controlBar.gotoAndStop(0);

  	if(!freeMode) {
  		thy.controlBar.visible = true;

  		thy.mcMedium.turnInactive();
  		thy.mcFast.turnInactive();
  		thy.mcCum.turnInactive();

  		rt.EDV.controlBar = new EventDirector(
  			rt.EH, "controlBar", rt, "CHANGE_LOAD_STATUS", fnBarControl,
  			rt, {owner: ownerName, groups: [mainGroupLabel]}
  		);
  		rt.EDV.controlBar.createEvent();
  	} else {
  		thy.controlBar.visible = false;

  		thy.mcMedium.turnActive();
  		thy.mcMedium.initState();

  		thy.mcFast.turnActive();
  		thy.mcFast.initState();

  		thy.mcCum.turnActive();
  		thy.mcCum.initState();
  	}

  	rt.EDV.controlsContainerVisibleStatusHandler = new EventDirector(
  		rt.EH, "controlsContainerVisibleStatusListener", rt,
  		"VISIBLE_STATUS_CHANGED", function(){
  			thy.visible = rt.GCFG.OBJECTS_VISIBLE;
  		},
  		rt, {owner: ownerName, groups: [mainGroupLabel]}
  	);
  	rt.EDV.controlsContainerVisibleStatusHandler.createEvent();

  	rt.EDV.controlSlow = new EventDirector(
  		rt.EH, "slowControl", thy.btnSlow, "click", thy.givenFnButtonSlowClick,
  		rt, {owner: ownerName, groups: [mainGroupLabel]}
  	);
  	rt.EDV.controlMedium = new EventDirector(
  		rt.EH, "mediumControl", rt, "MEDIUM_CONTROL", thy.givenFnMediumControl,
  		rt, {owner: ownerName, groups: [mainGroupLabel]}
  	);
  	rt.EDV.controlFast = new EventDirector(
  		rt.EH, "fastControl", rt, "FAST_CONTROL", thy.givenFnFastControl,
  		rt, {owner: ownerName, groups: [mainGroupLabel]}
  	);
  	rt.EDV.controlCum = new EventDirector(
  		rt.EH, "cumControl", rt, "CUM_CONTROL", thy.givenFnCumControl,
  		rt, {owner: ownerName, groups: [mainGroupLabel]}
  	);
  	rt.EDV.controlSlow.createEvent();
  	rt.EDV.controlMedium.createEvent();
  	rt.EDV.controlFast.createEvent();
  	rt.EDV.controlCum.createEvent();
  }

  function fnBarControl(e) {
  	switch(rt.GCFG.loadStatus) {
  		case 2:
  			e.timeBarReference.stop();
  			thy.mcMedium.turnActive();
  			thy.mcMedium.initState();
  			break;
  		case 4:
  			e.timeBarReference.stop();
  			thy.mcFast.turnActive();
  			thy.mcFast.initState();
  			break;
  		case 6:
  			e.timeBarReference.stop();
  			thy.mcCum.turnActive();
  			thy.mcCum.initState();
  	}
  }

  thy.readyChecker = true;
}

function setControlsContainerCumFunctionality(thy, rt, mainGroupLabel="lblCum", ownerName="CONTROLS_CONTAINER_CUM") {
  thy.initVars = function() {
  	rt.EA.turnOffAndDeleteEventsOfGroup(mainGroupLabel);

  	delete thy.readyChecker;
  }

  thy.initState = function() {
  	thy.mcCum.turnActive();
  	thy.mcCum.initState();

  	thy.mcNext.turnActive();
  	thy.mcNext.initState();

  	rt.EDV.controlsContainerCumVisibleStatusHandler = new EventDirector(
  		rt.EH, "controlsContainerCumVisibleStatusListener", rt,
  		"VISIBLE_STATUS_CHANGED", function(){
  			thy.visible = rt.GCFG.OBJECTS_VISIBLE;
  		},
  		rt, {owner: ownerName, groups: [mainGroupLabel]}
  	);
  	rt.EDV.controlsContainerCumVisibleStatusHandler.createEvent();

  	rt.EDV.controlCum = new EventDirector(
  		rt.EH, "cumControl", rt, "CUM_CONTROL", thy.givenFnCumControl,
  		rt, {owner: ownerName, groups: [mainGroupLabel]}
  	);
  	rt.EDV.nextControlCum = new EventDirector(
  		rt.EH, "nextCumControl", rt, "NEXT_CONTROL", thy.givenFnCumControlNext,
  		rt, {owner: ownerName, groups: [mainGroupLabel]}
  	);
  	rt.EDV.controlCum.createEvent();
  	rt.EDV.nextControlCum.createEvent();
  }

  thy.readyChecker = true;
}

/* setMovieContainerFunctionality(this, exportRoot, "movie00", function() {
	exportRoot.SLIB.Lily.play();
}, 1.2); */
function setMovieContainerFunctionality(thy, rt, MOVIE_ID, fnSounds, et1, et2=null, mainGroupLabel="lblMovie", ownerName="MOVIE_CONTAINER") {
  console.log("On setMovieContainerFunctionality");

  thy.initVars = function() {
  	delete thy.readyChecker;
  	delete thy.playedOnce;

    thy.VIDEO_SPEED = "SLOW";

    rt.EDV.videoTickHandler = new EventDirector(
      rt.EH, "videoTickListener", rt, "tick", thy.fnTick,
      rt, {owner: ownerName, groups:[mainGroupLabel]}
    );
    rt.EDV.videoTickHandler.createEvent();
  }

  thy[MOVIE_ID].on("added", function() {
  	$('#'+MOVIE_ID)[0].pause();

    thy.videoAdded = true;
  }, thy, true);

  thy.pauseClip = function() {
  	$('#'+MOVIE_ID)[0].pause();
  }

  thy.playClip = function() {
  	$('#'+MOVIE_ID)[0].play();
  }

  thy.changeClipSpeed = function(rate=1, argSpeed) {
  	$('#'+MOVIE_ID)[0].playbackRate = rate;

    thy.VIDEO_SPEED = argSpeed;
  	thy.playedOnce = true;
  }

  thy.fnTick = getTickFunction();

  function getTickFunction() {
    return function(e) {
      var eTime = $('#'+MOVIE_ID)[0].currentTime; // eTime: elapsedTime
      var etev = (typeof et2 =="undefined") ? // elapsed time evaluation
        (et1>=eTime && (et1+0.2)>=eTime) : (et1>=eTime && et2>=eTime);
      etev = (eTime>et1 && eTime<et2);

      if(thy.videoAdded && thy.playedOnce && rt.GCFG.SOUND && etev) {
        fnSounds();
      }
    }
  }

  thy.readyChecker = true;
}

function setMovieCumContainerFunctionality(thy, rt, MOVIE_ID, fnSounds, et1, et2=null, mainGroupLabel="lblCum", ownerName="MOVIE_CONTAINER_CUM") {
  thy.initVars = function() {
  	delete thy.readyChecker;
  	delete thy.playedOnce;

    rt.EDV.videoTickHandler = new EventDirector(
      rt.EH, "videoTickListener", rt, "tick", thy.fnTick,
      rt, {owner: ownerName, groups:[mainGroupLabel]}
    );
    rt.EDV.videoTickHandler.createEvent();
  }

  thy[MOVIE_ID].on("added", function() {
  	$('#'+MOVIE_ID)[0].pause();

    thy.videoAdded = true;
  }, this, true);

  thy.pauseClip = function() {
  	$('#'+MOVIE_ID)[0].pause();
  }

  thy.playClip = function() {
  	$('#'+MOVIE_ID)[0].play();

  	thy.playedOnce = true;
  }

  thy.fnTick = getTickFunction();

  function getTickFunction() {
    return function(e) {
      var eTime = $('#'+MOVIE_ID)[0].currentTime; // eTime: elapsedTime
      var etev = (typeof et2 =="undefined") ? // elapsed time evaluation
        (et1>=eTime && (et1+0.2)>=eTime) : (et1>=eTime && et2>=eTime);
      etev = (eTime>et1 && eTime<et2);

      if(thy.videoAdded && thy.playedOnce && rt.GCFG.SOUND && etev)
        fnSounds();
    }
  }

  thy.readyChecker = true;
}

function setBtnMediumFunctionality(thy, rt, mainGroupLabel="lblMovie", ownerName="CONTROLS_CONTAINER") {
  thy.initState = function() {
  	rt.EDV.mcBtnMedium = new EventDirector(
  		rt.EH, "btnMedium", thy.btnActual, "click", fnButtonClick,
  		rt, {owner: ownerName, groups: [mainGroupLabel]}
  	);
  	rt.EDV.mcBtnMedium.createEvent();
  }

  thy.turnActive = function() {
  	thy.gotoAndStop(1);
  }

  thy.turnInactive = function() {
  	thy.gotoAndStop(0);
  }

  function fnButtonClick() {
  	rt.dispatchEvent("MEDIUM_CONTROL");
  }
}

function setBtnFastFunctionality(thy, rt, mainGroupLabel="lblMovie", ownerName="CONTROLS_CONTAINER") {
  thy.initState = function() {
  	rt.EDV.mcBtnFast = new EventDirector(
  		rt.EH, "btnFast", thy.btnActual, "click", fnButtonClick,
  		rt, {owner: ownerName, groups: [mainGroupLabel]}
  	);
  	rt.EDV.mcBtnFast.createEvent();
  }

  thy.turnActive = function() {
  	thy.gotoAndStop(1);
  }

  thy.turnInactive = function() {
  	thy.gotoAndStop(0);
  }

  function fnButtonClick() {
  	rt.dispatchEvent("FAST_CONTROL");
  }
}

function setBtnCumFunctionality(thy, rt, mainGroupLabel="lblMovie", ownerName="CONTROLS_CONTAINER") {
  thy.initState = function() {
  	rt.EDV.mcBtnCum = new EventDirector(
  		rt.EH, "btnCum", thy.btnActual, "click", fnButtonClick,
  		rt, {owner: ownerName, groups: [mainGroupLabel]}
  	);
  	rt.EDV.mcBtnCum.createEvent();
  }

  thy.turnActive = function() {
  	thy.gotoAndStop(1);
  }

  thy.turnInactive = function() {
  	thy.gotoAndStop(0);
  }

  function fnButtonClick() {
  	rt.dispatchEvent("CUM_CONTROL");
  }
}

function setBtnNextFunctionality(thy, rt, mainGroupLabel="lblMovie", ownerName="CONTROLS_CONTAINER") {
  thy.initState = function() {
  	rt.EDV.mcBtnNext = new EventDirector(
  		rt.EH, "btnNext", thy.btnActual, "click", fnButtonClick,
  		rt, {owner: ownerName, groups: [mainGroupLabel]}
  	);
  	rt.EDV.mcBtnNext.createEvent();
  }

  thy.turnActive = function() {
  	thy.gotoAndStop(1);
  }

  thy.turnInactive = function() {
  	thy.gotoAndStop(0);
  }

  function fnButtonClick() {
  	rt.dispatchEvent("NEXT_CONTROL");
  }
}

function setControlBarFunctionality(thy, rt, eventName="CHANGE_LOAD_STATUS") {
  if(rt.SUPER_LIST.controlBarListener == undefined)
    rt.SUPER_LIST.controlBarListener = rt.on("tick", fnLoadStatus);

  var _six = thy.totalFrames-1;
  var _five = Math.floor(thy.totalFrames*0.70);
  var _four = _five+1;
  var _three = Math.floor(thy.totalFrames*0.28);
  var _two = _three+1;

  function fnLoadStatus(e) {
    switch (thy.currentFrame) {
      case 0:
        dispatchLoadEvent(0); // 0: Not started
        break;
      case 1:
        dispatchLoadEvent(1); // 1: On SLOW load
        break;
      case _two:
        dispatchLoadEvent(2); // 2: SLOW finished
        break;
      case _three:
        dispatchLoadEvent(3); // 3: On MEDIUM load
        break;
      case _four:
        dispatchLoadEvent(4); // 4: MEDIUM finished
        break;
      case _five:
        dispatchLoadEvent(5); // 5: On FAST load
        break;
      case _six:
        thy.stop();
        dispatchLoadEvent(6); // 6: ENDED

        rt.off("tick", rt.SUPER_LIST.controlBarListener);
        delete rt.SUPER_LIST.controlBarListener;
        break;
    }
  }

  function dispatchLoadEvent(status) {
    var tempLoadEvent = new createjs.Event(eventName);
  	tempLoadEvent.timeBarReference = thy;

  	rt.GCFG.loadStatus = status;
  	rt.dispatchEvent(tempLoadEvent);
  }
}

function setLblMovieFunctionality(thy, freeMode, controlsParent, videoParent, sSpeed, mSpeed, fSpeed, nextScn, frameLabel="lblMovie") {
  thy.setNormalButtonsFunctions = function() {
  	controlsParent.givenFnButtonSlowClick = function(e) {
  		videoParent.playClip();
  		videoParent.changeClipSpeed(sSpeed, "SLOW");
      if(thy.GCFG.loadStatus<1)
  		  controlsParent.controlBar.play();
  	}
  	controlsParent.givenFnMediumControl = function(e) {
  		videoParent.changeClipSpeed(mSpeed, "MEDIUM");
      if(thy.GCFG.loadStatus<3)
  		  controlsParent.controlBar.play();
  	}
  	controlsParent.givenFnFastControl = function(e) {
  		videoParent.changeClipSpeed(fSpeed, "FAST");
      if(thy.GCFG.loadStatus<5)
  		  controlsParent.controlBar.play();
  	}
  	controlsParent.givenFnCumControl = function(e) {
  		thy.EA.turnOffAndDeleteEventsOfGroup(frameLabel);
  		thy.gotoAndStop(nextScn);
  	}
  }

  thy.setFreeModeButtonsFunctions = function() {
  	controlsParent.givenFnButtonSlowClick = function(e) {
  		videoParent.playClip();
  		videoParent.changeClipSpeed(sSpeed, "SLOW");
  	}
  	controlsParent.givenFnMediumControl = function(e) {
      videoParent.playClip();
  		videoParent.changeClipSpeed(mSpeed, "MEDIUM");
  	}
  	controlsParent.givenFnFastControl = function(e) {
      videoParent.playClip();
  		videoParent.changeClipSpeed(fSpeed, "FAST");
  	}
  	controlsParent.givenFnCumControl = function(e) {
  		thy.EA.turnOffAndDeleteEventsOfGroup(frameLabel);
  		thy.gotoAndStop(nextScn);
  	}
  }

  if(!freeMode)
    thy.setNormalButtonsFunctions();
  else
    thy.setFreeModeButtonsFunctions();

  controlsParent.initVars();
	controlsParent.initState(freeMode); // freeModeStatus: playStatus>=15
	videoParent.initVars();
}

function setLblCumFunctionality(thy, freeMode, controlsParent, videoParent, nextScnID, nextScn, nextScnFree, frameLabel="lblCum") {
  controlsParent.givenFnCumControl = function(e) {
		videoParent.playClip();
	}
	controlsParent.givenFnCumControlNext = function(e) {
    thy.GCFG.SCENE = nextScnID;
    thy.EA.turnOffAndDeleteEventsOfGroup(frameLabel);

		if(freeMode)
			thy.gotoAndStop(nextScnFree);
		else
			thy.gotoAndStop(nextScn);
	}

  controlsParent.initVars();
	controlsParent.initState();
	videoParent.initVars();
}
